#ifndef _ITP_H_
#define _ITP_H_

#include <wx/wx.h>
#include <wx/treectrl.h>
#include <map>

#include	"libnw/itp.h"
#include	"libnw/bendian.h"
#include	"libnw/restyp.h"
#include	"libnw/are.h"
#include	"libnw/tlk.h"
#include	"libnw/uti.h"
#include	"libnw/utc.h"
#include	"libnw/git.h"
#include	"libnw/gic.h"
#include	"libnw/utp.h"
#include	"libnw/ute.h"
#include	"libnw/utd.h"
#include	"libnw/uts.h"
#include	"libnw/utm.h"
#include	"libnw/jrl.h"
#include	"libnw/ifo.h"
#include	"libnw/fac.h"
#include	"libnw/dlg.h"
#include	"libnw/utw.h"
#include	"libnw/bic.h"
#include	"libnw/gui.h"
#include	"libnw/utt.h"
#include	"libnw/ptt.h"
#include	"libnw/gff.h"

#include "config.h"

#include "NWNDataType.h"

class ITPResource {
 protected:
    std::string itpFileName;
    int offset;
    struct nwn_itp head;
    struct nwn_itp_list* listp;
    struct nwn_itp_data* datap;
    struct nwn_itp_tag* tagp;
    char* valuep;
    int* rootp;
    int* indexp;

    std::map<std::string,int> nameToIndexMap;

    void readITPFile();
    bool checkSignature(const char* s, const char* v) const;
    void makeMap();
    void mapItem(int i);

 public:
    ITPResource();
    ITPResource(std::string fname, int offset);
    ~ITPResource();
    ITPResource& fromFile(std::string fname, int offset);
    NWNDataType getItemByName(std::string name) const;
    NWNDataType getItemByIndex(int index) const;
    std::string getDescription() const;
    std::string getName() const;
    std::string getResRef() const;
    std::string getTag() const;
};
#endif
