#ifndef _MODFILE_H_
#define _MODFILE_H_

#include <string>
#include <map>

#include "libnw/agg.h"
#include "libnw/restyp.h"

#include "config.h"

#include "ITPResource.h"

class MODFile : public std::map<std::pair<std::string,std::string>,int> {
 protected:
    std::string modFileName;
    struct nwn_agg_toc *toc;
    std::map<int,std::pair<std::string,std::string> > indexToNameMap;
    std::map<std::string,std::map<std::string,ITPResource> > itpResources;
    int getFileOffset(std::string name, std::string ext) const;
 public:
    MODFile();
    MODFile(std::string fname, int offset);    
    void loadFile(std::string fname);
    void loadFile(std::string fname, int offset);
    int getFileOffset(int index) const;
    std::string getName(int index) const;
    std::string getType(int index) const;
    std::pair<std::string,std::string> getNameAndType(int index) const;
    ITPResource& getITPResource(int index);
    ITPResource& getITPResource(std::string name, std::string ext);
};
#endif
